<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: wildcard_request_parameter.php,v 1.4 2003/07/23 17:35:39 glandium Exp $

include_once(PAPAAN_BASE.'/components/matcher.php');

/**
* Matches a Request Parameter 
*
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: wildcard_request_parameter.php,v 1.4 2003/07/23 17:35:39 glandium Exp $
* @package  papaan
*/
class matcher_wildcard_request_parameter extends matcher_wildcard
{

    function matcher_wildcard_request_parameter (&$sitemap, $config) {

		parent::matcher_wildcard($sitemap, $config);
		$xpath = xpath_new_context($this->config['dom']);
		$xnode = xpath_eval($xpath,'/config/parameter-name');
		if (count($xnode->nodeset) != 1) {
			papaan::raiseError('Exactly one header-name definition expected in configuration',PAPAAN_ERROR_FATAL);
		}
		$this->parameter_name = $xnode->nodeset[0]->get_content();
    }

	function match($value)
    {
		if ($param = $this->sitemap->request->get_parameter($this->parameter_name)) {
			return parent::match($value, $param);
		}
		$this->setMatcherHits(array());
		return False;
	}
}
