<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: xslt.php,v 1.9 2003/07/24 18:03:51 glandium Exp $

include_once(PAPAAN_BASE.'/components/transformer.php');

/**
* Transforms an XML-Document with the help of libxslt out of domxml
*
* libxslt is the Gnome XSLT-Processor from the libxml project.
* It's integrated in ext/domxml since 4.2 and has the big advantage
*  that it takes a DomDocument Object for processing. Furthermore
*  it's said to be much faster than sablotron.
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: xslt.php,v 1.9 2003/07/24 18:03:51 glandium Exp $
* @package  papaan
*/
class transformer_xslt extends transformer {

    function transformer_xslt (&$sitemap, $config) {
		
		$this->transformer($sitemap, $config);
    }

    function DomStart(&$xml)
    {
        parent::DomStart($xml);
        $xslfile = $this->getAttrib('src');
	// Quick hack to avoid <xsl:include> opening files in bad directory
	$current_dir = getcwd();
	$dir = $this->sitemap->base_dir . '/' . $xslfile;
	chdir(dirname($dir));
        $xsl = domxml_xslt_stylesheet($this->readfile($xslfile,false));
	chdir($current_dir);
        $this->printDebug('XSL-File: '.$xslfile);

        $xslparams = $this->getParameter();
	$xslparams['PAPAAN_VERSION'] = PAPAAN_VERSION;
	$xslparams['PAPAAN_STRING'] = PAPAAN_STRING;
	$xslparams['REQUEST_URI'] = $_SERVER['REQUEST_URI'];
        $xml = $xsl->process($xml,$xslparams,False);
//        $xml = $xsl->process($xml,$xslparams,False,'/tmp/profiling');
    }
}


?>
