<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsp="http://apache.org/xsp" xmlns:set="http://exslt.org/sets" extension-element-prefixes="set">
<xsl:output omit-xml-declaration="yes" indent="no" encoding="UTF-8" method="xml"/>
<xsl:param name="namespace-uri">http://apache.org/xsp</xsl:param>
<xsl:include href="logicsheet-util.xsl"/>

<xsl:template match="/">
   <xsl:processing-instruction name="php">
   <xsl:apply-templates select="xsp:page"/>
   </xsl:processing-instruction>
</xsl:template>

<xsl:template match="xsp:page">
    <xsl:apply-templates select="xsp:structure"/>
    $dom = domxml_new_doc('1.0');
    <xsl:apply-templates select="xsp:logic"/>
<!--    <xsl:apply-templates select="xsp:init-page"/> -->
    <xsl:apply-templates select="*[namespace-uri() != $namespace-uri][position() = 1]"/>
<!--    <xsl:apply-templates select="xsp:exit-page"/> -->
    return $dom;
</xsl:template>

<xsl:template match="*[namespace-uri() != $namespace-uri]">
$new_node = $dom->create_element('<xsl:value-of select="name()"/>');
$node->add_child($new_node);
$node = $new_node;
<xsl:apply-templates/>
$node = $node->parent_node();
</xsl:template>

<xsl:template match="xsp:page/*[namespace-uri() != $namespace-uri]">
<xsl:choose>
<xsl:when test="namespace-uri()">
$node = $dom->create_element_ns('<xsl:value-of select="namespace-uri"/>','<xsl:value-of select="local-name()"/>','<xsl:value-of select="substring-before(name(),':')"/>');
</xsl:when>
<xsl:otherwise>
$node = $dom->create_element('<xsl:value-of select="local-name()"/>');
</xsl:otherwise>
</xsl:choose>
$dom->add_child($node);
<xsl:apply-templates select="node()"/>
</xsl:template>

<xsl:template match="xsp:structure/xsp:include">
include_once('<xsl:call-template name="escapeSingleQuotes"><xsl:with-param name="text" select="."/></xsl:call-template>');
</xsl:template>

<xsl:template match="xsp:param"/>

<xsl:template match="xsp:content|xsp:logic">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="xsp:expr">
<xsl:choose>
<xsl:when test="namespace-uri(..) = $namespace-uri and local-name(..) != 'content' and local-name(..) != 'element'">
<xsl:value-of select="."/>
</xsl:when>
<xsl:otherwise>
$node->add_child($dom->create_text_node(<xsl:value-of select="."/>));
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="xsp:element">
$new_node = $dom->create_element(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>);
$node->add_child($new_node);
$node = $new_node;
<xsl:apply-templates/>
$node = $node->parent_node();
</xsl:template>

<xsl:template match="xsp:attribute">
$node->set_attribute(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>,<xsl:apply-templates/>);
</xsl:template>

<xsl:template match="text()">
<xsl:choose>
<xsl:when test="namespace-uri(..) = $namespace-uri and (local-name(..) = 'expr' or local-name(..) = 'logic')">
<xsl:value-of select="."/>
</xsl:when>
<xsl:otherwise>
$node->add_child($dom->create_text_node('<xsl:value-of select="."/>'));
</xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
